var http = require("http"),
    url = require("url"),
    path = require("path"),
    fs = require("fs"),
    exec = require("child_process").exec,
    port = process.argv[2] || 2000;
 
http.createServer(function(request, response) {
 
  var uri = url.parse(request.url).pathname
    , filename = path.join(process.cwd(), uri);
  
  fs.exists(filename, function(exists) {
    if(!exists) {
      response.writeHead(404, {"Content-Type": "text/plain"});
      response.write("404 Not Found\n");
      response.end();
      return;
    }
 
    fs.readFile(filename, "binary", function(err, file) {
      if(err) {        
        response.writeHead(500, {"Content-Type": "text/plain", "Access-Control-Allow-Origin": "*"});
        response.write(err + "\n");
        response.end();
        return;
      }
      
      response.writeHead(200, {"Content-Type": "application/json",  "Access-Control-Allow-Origin": "*"});
      exec('../jl < '+filename,
	   function (error, stdout, stderr) {
	       response.write(stdout);
	       console.log('stderr: ' + stderr);
	       if (error !== null) {
		   console.log('exec error: ' + error);
	       }
	       response.end();
	   });
    });
  });
}).listen(parseInt(port, 10));
 
console.log("Static file server running at\n  => http://localhost:" + port + "/\nCTRL + C to shutdown");