type action = Ast | Sast | Interpret | Bytecode | Compile

let _ =
  let action = if Array.length Sys.argv > 1 then
    List.assoc Sys.argv.(1) [ ("-a", Ast);
			      ("-i", Interpret);
			      ("-b", Bytecode);
			      ("-s", Sast);
			      ("-c", Compile) ]
  else Compile in
  let lexbuf = Lexing.from_channel stdin in
  let program = List.rev (Parser.program Scanner.token lexbuf) in
  match action with
    Ast        -> let listing = Ast.string_of_program program
                  in print_string listing
  | Sast       -> ignore(Sast.check program)
  | Interpret  -> ignore(Sast.check program); ignore (Interpreter.run program)
	| Bytecode   -> ignore(Sast.check program);
	                let listing =
                      Bytecode.string_of_prog (Compile.translate program)
                  in print_endline listing
  | Compile    -> Execute.execute_prog (ignore(Sast.check program); Compile.translate program)