%{ open Ast %}

%token LBRACE RBRACE COMMA LBRACKET RBRACKET
%token COLON
%token TRUE FALSE
%token NULL
%token <int> LITERAL
%token <float> FLOAT
%token <bool> BOOLEAN
%token <string> STR
%token EOF

%start expr
%type <Ast.expr> expr

%%

expr:
    LITERAL          { Literal($1) }
  | STR              { Str($1) }
  | FLOAT            { Float($1) }
  | BOOLEAN          { Boolean($1) }
  | NULL             { Undef }
  | LBRACKET exprs_opt RBRACKET { Lis($2) }
  | LBRACE kvpairs_opt RBRACE { Hash($2)  } 

exprs_opt:
    /* nothing */ { [] }
  | exprs_list { List.rev $1 }

exprs_list:
    expr                    { [$1] }
  | exprs_list COMMA expr   { $3 :: $1 }

kvpairs_opt:
    /* nothing */ { [] }
  | kvpairs_list  { List.rev $1 }

kvpairs_list:
    STR COLON expr                    { [($1, $3)] }
  | kvpairs_list COMMA STR COLON expr { ($3, $5) :: $1 } 
