{ open Jparser }

rule token = parse
  [' ' '\t' '\r' '\n'] { token lexbuf } (* Whitespace *)
| ['\"']([^'\r' '\n' '\"']|"\\\"")*['\"'] as sc     { STR(sc) }
| '{'      { LBRACE }
| '}'      { RBRACE }
| ":"      { COLON }
| '['      { LBRACKET }
| ']'      { RBRACKET }
| ','      { COMMA }
| "null"   { NULL }
| ['0'-'9']+['.']['0'-'9']+ as lxm { FLOAT(float_of_string lxm) }
| "true"|"false" as bool { BOOLEAN(bool_of_string bool) }
| ['-']?['0'-'9']+ as lxm { LITERAL(int_of_string lxm) }
(*| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { ID(lxm) }*)
| eof { EOF }
| _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }
