#!/bin/bash

failedTests=0

echo "Running Tests"
for test in *.jl
do    
	output=$(../jl -i $1 < "$test" 2>&1)	
	correct=$(cat "$test".output)
	if [ "$output" != "$correct" ]
	then
	    failedTests=$(($failedTests+1))
	    echo "Failed $test. Expected '$correct' but got '$output'"
	fi
done

if [ $failedTests -gt 0 ]
then
    echo "Failed $failedTests test(s)"
else
    echo "All tests passed!"
fi