(*utility functions*)

let rec t_of_jexpr = function
    Ast.Literal i   -> Types.Int i
  | Ast.Str s       -> Types.Str s
  | Ast.Float f     -> Types.Float f
  | Ast.Boolean b   -> Types.Boolean b
  | Ast.Lis l       -> Types.Lis (List.map t_of_jexpr l)
  | Ast.Hash h      -> Types.Hash (List.map (fun (s, e) -> (s, t_of_jexpr e)) h)
  | Ast.Undef       -> Types.Undef
  | _               -> raise (Failure "Expression is not valid json")

let gets = function
    Types.Str s ->
      let ic, oc = Unix.open_process ("curl -s " ^ s) in
      let buf = Buffer.create 16 in
      (try
        while true do
          Buffer.add_channel buf ic 1
        done
      with End_of_file -> ());
    let _ = Unix.close_process (ic, oc) in
    Types.Str (Buffer.contents buf)
  | _           -> raise (Failure "Parameter has to be a string")

let parse t = match t with
    Types.Str s -> let lexbuf = Lexing.from_string s in
                   let expr = Jparser.expr Jscanner.token lexbuf in t_of_jexpr expr
  | _           -> raise (Failure "Parameter has to be a string")

